/* 

File: main.h

Copyright (c) 2010 Department of Information Engineering, University of Padova, Italy
Contributors: Davide Zordan, 11 Feb. 2010
All rights reserved

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * The name of the author may not be used to endorse or promote
      products derived from this software without specific prior
      written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _MAIN_H
#define	_MAIN_H

#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
//#include <windows.h>
//#include <winsock.h>
//#include <winsock2.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include <iostream>
//#include <ctime>
//#include <algorithm>
#include <math.h>
#include "newmat_lib/newmat.h"
#include "newmat_lib/newmatap.h"
#include "newmat_lib/newmatio.h"

using namespace std;

#define MAXPENDING 5    // Max connection requests
#define BUFFSIZE 65536

//flag di controllo dei messaggi
#define PREAMBLE 0
#define NEW_SENSOR 1
#define END_OF_SENSORS 2
#define NEW_MEASURE 3
#define RESPONSE 4

//tipe of measures
#define TEMPERATURE 0
#define HUMIDITY 1
#define LUMINOSITY1 2
#define LUMINOSITY2 3
#define VOLTAGE 4

struct sensorMeasures {
    int32_t id;
    float* value;
    int64_t* timestamp;
    float* valuePos;
    int64_t* tsPos;

    void resetPtrs() {
        valuePos = &value[0];
        tsPos = &timestamp[0];
    }
};

struct lastIter {
    Matrix* Phi_prec;
    ColumnVector* y_prec;
    ColumnVector* x_prec;
    float p_tx;
    int depth;
};

sensorMeasures* initMeasures;
sensorMeasures* finalMeasures;
lastIter last[5];
int32_t numSensors;
int32_t numMeasures;
int32_t ToM;         // <<<<<<<<<<<< aggiunto (va da 0 a 4, come specificato nelle #define)
time_t now;

//float err_threshold = 0.20;
//float err_threshold = 0.30;
//float err_threshold = 0.40;
//float err_threshold = 0.50;
//float err_threshold = 0.60;
//float err_threshold = 0.70;
//float err_threshold = 0.80;
float err_threshold = 0.90;
float  p_tx_min = 0.2;
float  C1 = 1.3;
float  C2 = 3;


int readBuffer(char* buffer, int dataLen);
int receiveData(int sock);
time_t max(time_t a, time_t b);
void reconstruct();
int sendResults(int sock);


#endif	/* _MAIN_H */

